【Leetcode】1:两数之和(Python)

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

 

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
 

解题思路

直接使用暴力方法,首先找到其中的一个数字,然后在这个数字之后找是否有加起来等于target的数字,没啥难度:

class Solution(object):
    def twoSum(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: List[int]
        """
        i = 0
        # 这里用了两个循环,最好只能使用一个循环
        while i < len(nums):
            j = i + 1
            while j < len(nums):
                if nums[i] + nums[j] == target:
                    return i, j
                j += 1
            i += 1
        return None

 方法二:使用排序+双指针法

首先将拿到的列表,进行sort排序,然后使用双指针,左指针指向第一个最小的元素,右指针指向最大的元素,将两个指针指向的数字分别相加,如果相加的数字大小比target的数字更大,那么说明我们需要减少这两个数字之和,右指针向左移动。反之,左指针向右移动,最终终将找到两个和为target的数字,这样一趟下来其时间复杂度只有O(n),比暴力方法所使用的O(n^2)更小。代码如下:

class Solution:
    def twoSum(self, nums: List[int], target: int) -> List[int]:
        new_ls=sorted(nums)
        left=0
        right=len(new_ls)-1

        while left < right:
            if (new_ls[left]+new_ls[right]) > target:
                right-=1
            if (new_ls[left]+new_ls[right]) < target:
                left+=1
            if (new_ls[left]+new_ls[right]) == target:
                break

        index_one=nums.index(new_ls[left])
        nums[index_one]=-999999
        index_two=nums.index(new_ls[right])




        return [index_one,index_two]

 

 

posted @ 2020-09-05 21:08  Geeksongs  阅读(729)  评论(0编辑  收藏  举报

Coded by Geeksongs on Linux

All rights reserved, no one is allowed to pirate or use the document for other purposes.